/*
 * FreeModbus Libary: STM32 Port
 * Copyright (C) 2013 Armink <armink.ztl@gmail.com>
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 *
 * File: $Id: porttimer.c,v 1.60 2013/08/13 15:07:05 Armink $
 */

/* ----------------------- Platform includes --------------------------------*/

#include "includes.h"
#include "port.h"

/* ----------------------- Modbus includes ----------------------------------*/
#include "mb.h"
#include "mbport.h"
#include "mbconfig.h"


/* ----------------------- static functions ---------------------------------*/
static void prvvTIMERExpiredISR(void);

/* ----------------------- Start implementation -----------------------------*/
BOOL xMBPortTimersInit(USHORT usTim1Timerout50us)
{
	  TIMER0 ->CTL = TIMER_PERIODIC_MODE;
      TIMER_SET_CMP_VALUE(TIMER0 , usTim1Timerout50us*12*50);	
      TIMER_EnableInt(TIMER0);  
	  NVIC_EnableIRQ(TMR0_IRQn);
    return TRUE;
}

void vMBPortTimersEnable()
{
      TIMER_Start(TIMER0);	
}

void vMBPortTimersDisable()
{
	TIMER_Stop(TIMER0);
}

void prvvTIMERExpiredISR(void)
{
	(void) pxMBPortCBTimerExpired();
}

void TMR0_IRQHandler(void)
{
    OSIntEnter();		//ж
   TIMER_ClearIntFlag(TIMER0);
	 ( void )pxMBPortCBTimerExpired(  );
    OSIntExit();        //лж
}
