/*
 * FreeModbus Libary: STM32 Port
 * Copyright (C) 2013 Armink <armink.ztl@gmail.com>
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 *
 * File: $Id: porttimer_m.c,v 1.60 2013/08/13 15:07:05 Armink add Master Functions$
 */

/* ----------------------- Platform includes --------------------------------*/

#include "includes.h"
#include "port.h"

/* ----------------------- Modbus includes ----------------------------------*/
#include "mb.h"
#include "mb_m.h"
#include "mbport.h"
#include "mbconfig.h"

#if MB_MASTER_RTU_ENABLED > 0 || MB_MASTER_ASCII_ENABLED
/* ----------------------- Variables ----------------------------------------*/
static USHORT usT35TimeOut50us;

/* ----------------------- static functions ---------------------------------*/
static void prvvTIMERExpiredISR(void);

/* ----------------------- Start implementation -----------------------------*/
BOOL xMBMasterPortTimersInit(USHORT usTimeOut50us)
{
    TIMER1 ->CTL = TIMER_PERIODIC_MODE;
    TIMER_SET_CMP_VALUE(TIMER1 , usTimeOut50us*12*50);	
    TIMER_EnableInt(TIMER1);  
    NVIC_EnableIRQ(TMR1_IRQn);
    return TRUE;
}

void vMBMasterPortTimersT35Enable()
{
	TIMER_Start(TIMER1);
}

void vMBMasterPortTimersConvertDelayEnable()
{
	TIMER_Stop(TIMER1);
}

void vMBMasterPortTimersRespondTimeoutEnable()
{
    TIMER_Start(TIMER1);
}

void vMBMasterPortTimersDisable()
{
	TIMER_Stop(TIMER1);
}

void prvvTIMERExpiredISR(void)
{
	(void)pxMBMasterPortCBTimerExpired();
}

void TMR1_IRQHandler(void)
{
    OSIntEnter();		//ж    
   TIMER_ClearIntFlag(TIMER1);
	(void)pxMBMasterPortCBTimerExpired();
     OSIntExit();        //лж
}

#endif
